This file contains all the comments in the c't patch. The comments are
separated by file, and are in the same order as they appear in the program.
German appears first, followed by English.


File: Compatib.Pas   Unit Compatib
     { Nur die Int-Vektoren fr INT 0,4,5,6,7,$10 knnen }
     { gesetzt/gelesen werden.                           }
     { Only the int vectors for INT 0,4,5,6,7,$10 can be }
     { set and read.                                     }

File: PatchBP.Pas    Program PatchBP
     WriteLn('Fehler beim Patchen! Abbruch.');
     WriteLn('Error during patch!  Aborted.');

     WriteLn('Aufruf: PatchBP <Dateiname> C [701]  fr BPC.EXE');
     WriteLn('Call:   PatchBP <filename> C [701]  for BPC.EXE');

     WriteLn('        PatchBP <Dateiname> I [701]  fr BP.EXE');
     WriteLn('        PatchBP <filename> I [701]  for BP.EXE');

     WriteLn('        PatchBP <Dateiname> R [701]  fr BP.REZ');
     WriteLn('        PatchBP <filename> R [701]  for BP.REZ');

     { Kein InitTask() bei Programmstart. }
     { No InitTask() at the start of the program. }

     { Application Flags = 2. }
     { Application Flags = 2. }

     { (Compatible with Windowing API). }
     { (Compatible with Windowing API). }

     { Operating System = OS/2. }
     { Operating System = OS/2. }

     { Stub gibt 'This program requires OS/2' aus. }
     { Stub writes 'This program requires OS/2'. }

     { Compiler meldet sich mit 'Version 7OS2'. }
     { Compiler identifies itself with 'Version 7OS2'. }

     { Kommandozeilen-Parameter -CO = OS/2 target. }
     { Command line parameter -CO = OS/2 target. }

     { Standard-Unit-Extension ist 'TPO'. }
     { Standard-Unit-Extension is 'TPO'. }

     { 'OS2' als bedingtes Symbol definieren. }
     { define 'OS2' as conditional symbol. }

     { Compiler|Zielplattform einstellen = 'OS/2'. }
     { set Compiler|Target = 'OS/2'. }

     { Optionen|Compiler = 'OS/2'. }
     { Options|Compiler = 'OS/2'. }

     { Optionen|Speicherauslegung = 'OS/2'. }
     { Options|Memory sizes = 'OS/2'. }

     { Standard-Library ist 'OS2.TPL'. }
     { Standard library is 'OS2.TPL'. }

     { Compiler|Zielplattform = 'OS/2'. }
     { Compiler|Target = 'OS/2'. }

     { Compile-Box = 'OS/2'. }
     { Compile box = 'OS/2'. }

File: System     Unit System
     { Zeiger auf Kommandozeile.              }
     { Pointer to command line                }

     { Selektor der Heapliste.                }
     { Heap list selector                     }

     { Grenze fr 'Small Blocks'.             }
     { Small block limit                      }

     { Gre eines globalen Heap-Blocks.      }
     { Size of a global heap block            }

     { Heap-Allozierungsflags, SEG_NONSHARED. }
     { Heap allocation flags, SEG_NONSHARED.  }

     { Zeiger auf HeapError-Funktion.         }
     { Pointer to HeapError function.         }

     { Zeiger auf Exit-Prozedur.              }
     { Pointer to Exit Procedure.             }

     { Exit-Code des Programms.               }
     { Program exit code.                     }

     { Adresse des Runtime-Errors.            }
     { Runtime error address                  }

     { Selektor des Environment-Blocks.       }
     { Environment block selector             }

     { Fehlercode der I/O-Operationen.        }
     { I/O operation error code               }

     { Startwert fr Zufallsgenerator.        }
     { Random number generator seed.          }

     { Selektor-Inkrement-Wert.               }
     { Selector increment value.              }

     { Prozessortyp.                          }
     { Processor type.                        }

     { Dateimodus, OPEN_SHARE_DENYNONE.       }
     { OPEN_SHARE_DENYNONE.                   }

     { Standard-Eingabe.                      }
     { Standard input.                        }

     { Standard-Ausgabe.                      }
     { Standard output.                       }

     { Alter Vektor fr INT $00.              }
     { Old INT $00 vector.                    }

     { Alter Vektor fr INT $0C.              }
     { Old INT $0C vector.                    }

     { Alter Vektor fr INT $0D.              }
     { Old INT $0D vector.                    }


File: Thread      Program ThreadTest
     { Stack-berprfung sollte deaktiviert werden. }
     { Stack checking should be deactivated. }

     { Beende nur Thread1, nicht Programm. }
     { End only Thread1, not the program. }

     { Stack-berprfung kann wieder aktiviert werden. }
     { Stack checking can be re-activated. }

     { Alloziere Stack fr Thread1. }
     { Allocated stack for Thread1. }

     { Zeiger auf Prozedur f. Thread}
     { Pointer to Procedure for Thread}

     { Ende des Stackbereichs als Anfangswert fr SS:SP. }
     { End of the stack area as initial value for SS:SP. }

     { Gib Stack fr Thread1 frei. }
     { free stack for Thread1. }

File: Video.Pas       Program DirectVodeoAccess
     { Lese Zeiger auf logischen Video-Buffer.}
     { Read pointer to logical video buffer.}

     { Bildschirm aktualisieren. }
     { update display. }

