{$A+,B-,D-,E-,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X-,M 16384,0,0}

(*===================================================================*)
(*                            EXEGR.PAS                              *)
(*                 Copyright (C) 1993 te-wi Verlag                   *)
(*-------------------------------------------------------------------*)
(*  Demoprogramm, das seine effektive und die im Header angegebene   *)
(*                    Lnge ermittelt und ausgibt                    *)
(*===================================================================*)
(* Aufbau des EXE-Header (hierfr relevante Daten):                  *)
(* Byte_1 = "M"     = erstes Byte der Kennung                        *)
(* Byte_2 = "Z"     = zweites Byte der Kennung                       *)
(* DateigreinByte = ((Byte_6*256+Byte_5)-1)*512+(Byte_4*256+Byte_3)*)
(*-------------------------------------------------------------------*)
(* Die Daten im Exe-Header knnen dafr genutzt werden, um beim An-  *)
(* hngen zustzlicher Binrdateien (beispielsweise mit COPY/B) an   *)
(* das Programm selbst (OVL-Simulation) die Position dieser zustz-  *)
(* lich angehngten Daten zu finden (Addition der EXE-Gre).        *)
(* Die Funktion GetFileLenFromHeader bergibt immer die Lnge des    *)
(* vom Linker erstellten Programms zurck. Die Lnge der Datei, die  *)
(* durch Anhngen von anderen (Daten-Dateien) entstanden ist, kann   *)
(* einfach durch ffnen der Datei als untypisierte Datei mit einer   *)
(* Recordlnge von 1 ermittelt werden.                               *)
(* Ausprobiert knnen die Demofunktionen im Programm dadurch, da    *)
(* man an das Programm EXEGR.EXE eine beliebige andere Datei anhngt:*)
(* COPY/B EXEGR.EXE+TURBO.PCK TEST.EXE                               *)
(* Es wird einmal die ursprngliche Lnge von EXEGR.EXE ausgegeben   *)
(* und zustzlich noch die effektive Dateilnge.                     *)
(* Trotz der Lngennderung ist das Programm voll lauffhig, da im   *)
(* Gegensatz zu .COM-Dateien die Codelnge vom Linker festgelegt     *)
(* wird und nicht aus der Dateilnge errecht ist. Sptere nderungen *)
(* werden deshalb ignoriert. Den selben Effekt machen sich auch      *)
(* Linkviren zunutze. ber diesen Effekt kann deshalb auch ein in    *)
(* ein Programm eingebauter Virentest arbeiten:                      *)
(* 1. Test der Dateilnge ber GetFileLenFromHeader.                 *)
(* 2. Test der Dateilnge ber FileSize bei Recordlnge 1            *)
(* Bei nicht modifizierten Programmen mssen beide Werte gleich sein.*)
(*===================================================================*)

PROGRAM GetMyLength;

USES
  DosUtil;

VAR
  ExeFile: FILE;
  FSize,
  ExeLen : LONGINT;

BEGIN
  WriteLn('Programmdatei      :  ', ParamStr(0));
  ExeLen := ExeFileLength(ParamStr(0));
  IF ExeLen > 0 THEN
  BEGIN
    WriteLn('Programmlnge      : ', ExeLen:6, ' Bytes');
    Assign(ExeFile, ParamStr(0));
    Reset(ExeFile, 1);
    FSize := FileSize(ExeFile);
    WriteLn('Echte Dateilnge   : ', FSize:6, ' Bytes');
    Close(ExeFile);
    WriteLn('Angehngter Bereich: ', (FSize - FSize):6, ' Bytes');
  END
  ELSE
    WriteLn('Diese Datei ist kein gltiges Exe-Programm');
    (* --> Diese Meldung ist recht unwahrscheinlich, da das Programm *)
    (* nur dann startet, wenn es ein echtes Exe-File ist.            *)
END.

(*===================================================================*)
