{$A+,B-,D-,E-,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X-}
{$M 16384,0,655360}
(*===================================================================*)
(*                             TESTBGI.PAS                           *)
(*                  (C) 1993 te-wi Verlag Mnchen                    *)
(*===================================================================*)
(*    Fr dieses Programm mu der Treiber mit dem richtigen Wert     *)
(*         gepatcht sein. Benutzen Sie hierfr MAKEBGI.PAS           *)
(*===================================================================*)

PROGRAM TestSVGABGI;

USES
  Crt, Dos, Graph;

VAR
  gd, gm, result : INTEGER;
  SVGADriverPtr  : Pointer;
  f,
  MaxX, MaxY,
  i, j           : INTEGER;
  s              : STRING;

BEGIN
  gd := InstallUserDriver('SVGA', SVGADriverPtr);
  gm := 0;
  InitGraph(gd, gm, GetEnv('BGIPATH'));
  result := GraphResult;
  IF result < 0 THEN 
  BEGIN
    WriteLn(^G, GraphErrorMsg(result));
    Halt;
  END;
  SetColor(LightRed);
  MaxX := GetMaxX;
  MaxY := GetMaxY;
  Line(MaxX DIV 2, 0,
       MaxX DIV 2, MaxY - 2 * TextHeight('Pp'));
  SetColor(LightGreen);
  Line(0, MaxY DIV 2, MaxX, MaxY DIV 2);
  SetFillStyle(XHatchFill, Red);
  Bar(MaxX DIV 4,
      MaxY DIV 4,
      MaxX DIV 2 + MaxX DIV 4,
      MaxY DIV 2 + MaxY DIV 4);
  s := GetModeName(0);
  MoveTo(MaxX DIV 2 - TextWidth(s) DIV 2,
         MaxY - TextHeight('pP'));
  FOR i := 1 TO Length(s) DO 
  BEGIN
    SetColor(Succ(i));
    OutText(s[i]);
  END;
  SetColor(LightMagenta);
  Line(0, 0, MaxX, MaxY);
  Line(0, MaxY-1, MaxX-1, 0);
  i := MaxY DIV 2;
  SetFillStyle(SolidFill, Blue);
  SetColor(Blue);
  PieSlice(MaxX DIV 2, MaxY DIV 2, 0, 360, 20);
  SetColor(Yellow);
  WHILE i > 10 DO 
  BEGIN
    Dec(i, 20);
    Circle(MaxX DIV 2, MaxY DIV 2, i);
    IF i > 10 THEN
    Rectangle(i + GetMaxX DIV 2 ,
              i,
              MaxX - i - GetMaxX DIV 2,
              MaxY - i);
  END;
  REPEAT 
  UNTIL KeyPressed;
  CloseGraph;
END.

(*===================================================================*)
