PROGRAM NewCrt;
(* ---------------------------------------------------------------------- *)
(* Beispielprogramm zum Einhngen einer Menleiste in ein WINCRT-Programm *)
(* (c) 1993, Reebear @ Borland Deutschland GmbH, Starnberg                *)
(* ---------------------------------------------------------------------- *)

{$R NewCrt}

USES WinTypes, WinProcs, WinCrt;

CONST
  cm_Test = 101;
  cm_Exit = 102;

VAR
  Window: hWND;
  PrevWinProc: tFarProc;
  Menu: hMenu;
  i: WORD;

FUNCTION NewWndProc (Window: hWND; Message, wParam: WORD;
                      lParam: LONGINT): LONGINT; EXPORT;
BEGIN
  IF (Message = wm_Command) THEN
  BEGIN
    CASE wParam OF
      cm_Test: BEGIN
        MessageBox(Window, 'Hallo', 'Hallo', mb_OK);
        NewWndProc := 0;
      END;
      cm_Exit: DoneWinCrt;
      ELSE NewWndProc := CallWindowProc (PrevWinProc, Window, Message, wParam, lParam);
    END;
  END ELSE NewWndProc := CallWindowProc (PrevWinProc, Window, Message, wParam, lParam);
END;

BEGIN
  InitWinCrt;
  Window := GetActiveWindow;
  Menu := LoadMenu (hInstance, 'Menu_1');
  SetMenu (Window, Menu);
  PrevWinProc := tFarProc(GetWindowLong(Window, gwl_WndProc));
  SetWindowLong (Window, gwl_WndProc, LONGINT(@NewWndProc));
  FOR i := 1 TO 10 DO WriteLn ('Dies ist ein normales WinCrt-Fenster, oder nicht?');
  ReadLn;
  DoneWinCrt;
END.
