PROGRAM IconDlg;

{$R IconDlg}

USES OWindows, ODialogs, WinTypes, WinProcs;

CONST
  { Command ID }
  idm_About = 100;

TYPE
  pMyWindow = ^tMyWindow;
  tMyWindow = OBJECT (tWindow)
    CONSTRUCTOR Init (aParent: pWindowsObject; aTitle: pChar);
    PROCEDURE GetWindowClass (VAR aWndClass: tWndClass); VIRTUAL;
    PROCEDURE About (VAR Msg: tMessage); VIRTUAL cm_First + idm_About;
  END;

  tMyApplication = OBJECT (tApplication)
    PROCEDURE InitMainWindow; VIRTUAL;
  END;

CONSTRUCTOR tMyWindow.Init (aParent: pWindowsObject; aTitle: pChar);
BEGIN
  tWindow.Init (aParent, aTitle);
  Attr.Menu := LoadMenu(hInstance, 'Generic');
  Attr.w := 400;
  Attr.h := 300;
END;

PROCEDURE tMyWindow.GetWindowClass (VAR aWndClass: tWndClass);
BEGIN
  tWindow.GetWindowClass (aWndClass);
  aWndClass.hIcon := LoadIcon (hInstance, 'Haegar');
END;

PROCEDURE tMyWindow.About (VAR Msg: tMessage);
VAR Dialog: tDialog;
BEGIN
  Dialog.Init(@Self, 'AboutBox');
  Dialog.Execute;
  Dialog.Done;
END;

PROCEDURE tMyApplication.InitMainWindow;
BEGIN
  MainWindow := New (pMyWindow, Init(NIL, 'Generic OWL Application'));
END;

VAR
  GenericApp: tMyApplication;

BEGIN
  GenericApp.Init ('GenericApp');
  GenericApp.Run;
  GenericApp.Done;
END.
