(*===================================================================*)
(*                             EXTFONTS.PAS                          *)
(*       Bindet alle erweiterten Fonts ein und registriert sie       *)
(*===================================================================*)

Unit ExtFonts;

INTERFACE

VAR
  ScriptFont,
  TriplexScriptFont,
  SimplexFont,
  ComplexFont,
  EuropeanFont,
  BoldFont: INTEGER;

PROCEDURE ScriptFontProc;
PROCEDURE SimplexFontProc;
PROCEDURE TriplexScriptFontProc;
PROCEDURE ComplexFontProc;
PROCEDURE EuropeanFontProc;


IMPLEMENTATION

USES
  Graph, BoldFonts_;

PROCEDURE ScriptFontProc;        EXTERNAL; {$L SCRI.OBJ}
PROCEDURE SimplexFontProc;       EXTERNAL; {$L SIMP.OBJ}
PROCEDURE TriplexScriptFontProc; EXTERNAL; {$L TSCR.OBJ}
PROCEDURE ComplexFontProc;       EXTERNAL; {$L LCOM.OBJ}
PROCEDURE EuropeanFontProc;      EXTERNAL; {$L EURO.OBJ}


BEGIN
  ScriptFont        := RegisterBGIFont(@ScriptFontProc);
  SimplexFont       := RegisterBGIFont(@SimplexFontProc);
  TriplexScriptFont := RegisterBGIFont(@TriplexScriptFontProc);
  ComplexFont       := RegisterBGIFont(@ComplexFontProc);
  EuropeanFont      := RegisterBGIFont(@EuropeanFontProc);
  BoldFont          := RegisterBGIFont(@BoldFontProc);
END.

(*===================================================================*)
