(* ====================================================== *)
(*                     LPTTEST.PAS                        *)
(*          berprft serielle Schnittstelle(n)           *)
(*         (c) 1993 Ralf Hensmann & DMV-Verlag            *)
(* ====================================================== *)

{$A+,B-,D-,E-,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}

PROGRAM LPTTest;

USES ParData;

  FUNCTION HexW(W : WORD) : STRING;
  CONST
    HS : ARRAY [0..15] OF CHAR = '0123456789ABCDEF';
  BEGIN
    HexW[0] := #4;
    HexW[1] := HS[Hi(W) SHR 4];
    HexW[2] := HS[Hi(W) AND $F];
    HexW[3] := HS[Lo(W) SHR 4];
    HexW[4] := HS[Lo(W) AND $F];
  END;

VAR
  i : BYTE;

BEGIN
  WriteLn('LPTTest testet ihre Kartenadresse... ');
  WriteLn('Folgende parallele Schnittstellen sind in ',
          'ihrem Rechner verfgbar:');
  WriteLn;
  FOR i := 1 TO 3 DO
    IF GetLPTAdress(i) <> 0 THEN
      WriteLn('LPT', i, ' mit der Adresse $',
              HexW(GetLPTAdress(i)));
END.
(* ====================================================== *)
(*                 Ende von LPTTEST.PAS                   *)
