; ***************************************
; *        Autor : Robert Flogaus       *
; *        Datum : 13.3.1993            *
; *       Sprache: Turbo Assembler 2.0  *
; *                                     *
; *         Zweck: INCLUDE-Datei von    *
; *                chktsr.asm und       *
; *                tsrinfo.asm          *
; ***************************************

Save_CBreak EQU 104H

Test_MCBFlag PROC NEAR
  CMP DH,'M'
  JE @@Exit_M
  CMP DH,'Z'
  JE @@Exit_Z
Patch_27:
  MOV DX,OFFSET MemErr_Msg
  STC
  RET
@@Exit_M:
  CMP DH,'Z'
@@Exit_Z:
  CLC
  RET
Test_MCBFlag ENDP

CRLF PROC NEAR
  MOV AL,13
  CALL CharOut
  MOV AL,10
  CALL CharOut
  RET
CRLF ENDP

CharOut PROC NEAR
  PUSH DX
  MOV AH,2
  MOV DL,AL
  INT 21H
  POP DX
  RET
CharOut ENDP

Display_Exitmessage PROC NEAR
  PUSH CS
  POP DS
  PUSH AX
  CALL Old_UMB_Link_State
  CALL Old_Cbreak
  CALL CRLF
  MOV AH,9
  INT 21H
  CALL CRLF
  POP AX
  RET
Display_Exitmessage ENDP

CBreak_Off PROC NEAR
  PUSH DX
  MOV AX,3300H  ;get cbreak
  INT 21H
  MOV CS:[Save_CBreak],DL
  MOV AX,3301H
  XOR DX,DX ;cbreak off
  INT 21H
  POP DX
  RET
CBreak_Off ENDP

Old_Cbreak PROC NEAR
  PUSH DX
  MOV AX,3301H
  MOV DL,CS:[Save_CBreak]
  CMP DL,1
  JA @@No_Change
  INT 21H
@@No_Change:
  POP DX
  RET
Old_Cbreak ENDP

Old_UMB_Link_State PROC NEAR
  PUSH AX
  PUSH BX
Patch_28:
  MOV BL,BYTE PTR [Orig_UMB_Link_State]
  OR BL,BL
  JNZ @@Exit
  MOV BH,BL
  MOV AX,5803H ;remove UMBs from mem chain
  INT 21H
@@Exit:
  POP BX
  POP AX
  RET
Old_UMB_Link_State ENDP

Get_UMB_Link_State PROC NEAR
  XOR BX,BX
  MOV AX,3306H ;get dos ver (DOS 5.0)
  INT 21H
  CMP BL,5
  JB @@NOTHING
  MOV AX,5802H ;get umb link state
  INT 21H
  JC @@NOTHING
  CMP AL,2
  JNB @@NOTHING
Patch_29:
  MOV BYTE PTR [Orig_UMB_Link_State],AL
@@NOTHING:
  RET
Get_UMB_Link_State ENDP

New_UMB_Link_State PROC NEAR
  PUSH AX
  PUSH BX
  PUSH DX
Patch_30:
  CMP BYTE PTR [Orig_UMB_Link_State],1
  JNB @@Exit
  MOV AX,5803H
  MOV BX,1  ;add UMBs to memory chain
  INT 21H
@@Exit:
  POP DX
  POP BX
  POP AX
  RET
New_UMB_Link_State ENDP

Get_First_MCB_Seg PROC NEAR
  PUSH DX
  PUSH CX
  XOR BX,BX
  MOV ES,BX
  MOV AH,52H
  INT 21H
  MOV AX,ES
  MOV CX,AX
  OR CX,BX
  POP CX
  POP DX
  JZ @@Error
  DEC AX
  MOV ES,AX
  MOV AX,ES:[BX+14]
  CLC
  RET
@@Error:
  STC
  RET
Get_First_MCB_Seg ENDP

Mul16 PROC NEAR
  XOR CX,CX
  REPT 4
    SHL DX,1
    RCL CX,1
  ENDM
  RET
Mul16 ENDP
