PROGRAM MapReal;

USES WinTypes, WinProcs, WinDos, WinCrt;

VAR
  Regs: tRegisters;
  Yeah: BOOLEAN;
  Segm: WORD;
  Long: LONGINT;

FUNCTION DPMIInstalled: BOOLEAN;
BEGIN
  DPMIInstalled := FALSE;
  (* Ist DPMI installiert ?      *)
  Regs.AX := $1686;
  Intr ($2F, Regs);
  IF (Regs.AX = 0)
    THEN DPMIInstalled := TRUE;
END;

FUNCTION MapRealModeSegment(Segment: WORD): WORD;
(* Mit freundlichen Gruessen an FE *)
BEGIN
  MapRealModeSegment := 0;
  ASM
    MOV   BX, Segment
    MOV   AX, 0002H
    INT   31H
    JC    @@1
    MOV   WORD Ptr @Result, AX
  @@1:
  END;
END;

BEGIN
  InitWinCrt;
  Yeah := DPMIInstalled;

  IF Yeah THEN BEGIN
    Segm := MapRealModeSegment ($40);
    REPEAT
      Long := pLongInt(Ptr(Segm, $6C))^;
      WriteLn (Long);
    UNTIL KeyPressed;
  END;
  ReadLn;
  WriteLn ('Schleife abgebrochen, <CR> zum Beenden');
  ReadLn;

  DoneWinCrt;
END.
